/* -----------------------------------------------------------------------------------
   "main.c"

   This is the main function to the calculation between 2 floating point numbers.  The
   operations include adding, myltiplying, factorial with looping, factorial with
   recursion.  The program can be terminated by typing 'Q' or 'q' to quit.
   It allows only floating point numbers but no other kinds of values.
   
   This program uses a loop to ask the user to select the desire choice for operation.
   It ends with a "good-bye message".
   -----------------------------------------------------------------------------------
*/

#include "add.h"
#include "multiply.h"
#include "factorial.h"
#include "factorial2.h"

int main ()
{
	unsigned keepGoing;	/* to indicate loop to continue to execute */
	float num1;		/* first floating point number for calculation */
	float num2;		/* second floating point number for calculation */
	int n;			/* the value of the factorial */
	char task;		/* to select which operation for calculation */
	char choice;		/* to select which operation for factorial */

	keepGoing = 1;		/* initialize looping execution to true */
	while (keepGoing)	/* while true, keep looping */
	{
	   /* display menu for calculation operation */
	   printf("\nEnter task to perform (A is to add, M is to multiply, F is to
factorial, Q is to quit): ");

	   scanf("%c", &task);		/* read operation to perform */

	   /* for case to quit */
	   if ((task == 'q') || (task == 'Q'))
		keepGoing = 0;		/* end the task */

	   /* for case to add the 2 floating point numbers */
	   else if ((task == 'a') || (task == 'A'))
	   {
		/* ask to enter the 2 floating point numbers for calculation */
	   	printf("\nEnter first number, second number for the calculation\n");
	   	printf("and each input is separated by a blank space: ");

		/* read in the 2 floating point numbers */
	   	scanf("%f %f", &num1, &num2);

		add(num1,num2);		/* go to function add */
		continue;
	   }

	   /* for case to multiply the 2 floating point numbers */
	   else if ((task == 'm') || (task == 'M'))
	   {
		/* ask to enter the 2 floating point numbers for calculation */
		printf("\nEnter first number, second number for the calculation\n");
		printf("and each input is separated by a blank space: ");

		/* read in the 2 floating point numbers */
		scanf("%f %f", &num1, &num2);

		multiply(num1,num2);	/* go to function multiply */
		continue;
	   }		

	   /* if the task is to do factorial */
	   else if ((task == 'f') || (task == 'F'))
	   {
		/* ask for value of the factorial */
		printf("\nEnter the number to do the factorial, and the type of\n");
		printf("recursion wish to perform, loop (L) or recursion (R).\n");
		printf("Use a blank space to separate them: ");

		/* read value of the factorial and the type to perform it */
		scanf("%d %c", &n, &choice);

		/* if looping method is preferred */
		if ((choice == 'l') || (choice == 'L'))
		   factorial(n);	/* go to function factorial */

		/* if recursion method is preferred */
		else if ((choice == 'r') || (choice == 'R'))
		   factorial2(n);	/* fo to function factorial2 */

		else	/* display error message otherwise */
		   printf("ERROR!  Please re-enter the choice for factorial.\n");

		continue;   
	   }


	   else /* error:  display error message */
	   {
		printf("\nERROR!  Please re-enter the choice for task.\n");
		continue;
	   }
	}

	/* ending message */
	printf("\nThank you for using this program!\n");
	return 0;
}
